<?php
/**
 * Livewire Component
 *
 * @version     1.0.$Revision:$
 * @version     SVN: $Id:$
 * @package     bplan-base/globals
 * @subpackage  LivewireComponents
 * @author      Emilio Cannarozzo <emilio.cannarozzo@bplan-solutions.de>
 * @author      Wassilios Meletiadis <wassilios.meletiadis@bplan-solutions.de>
 * @copyright   Copyright (C) 2025, 2026 bplan-solutions GmbH & Co. KG <https://www.bplan-solutions.de/>
 * /Δ\
 */

namespace BplanBase\Globals\Livewire\Core\Tenant;


use BplanBase\Globals\DataGrid\DataGrid;
use BplanBase\Globals\Models\Tenant;
use BplanBase\Globals\Repositories\IndexCollectionRepository;
use BplanBase\Globals\Traits\WithDataGrid;
use Illuminate\Database\Eloquent\Collection;
use Illuminate\Pagination\LengthAwarePaginator;
use Livewire\Component;
use Livewire\WithPagination;


/**
 * Livewire Component
 *
 * @version     1.1.0 / 2026-06-09
 * @author      Emilio Cannarozzo <emilio.cannarozzo@bplan-solutions.de>
 * @author      Wassilios Meletiadis <wassilios.meletiadis@bplan-solutions.de>
 */
class Index extends Component
{


/* +++ TRAITS +++ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */


    use WithDataGrid;
    use WithPagination;


/* +++ CLASS CONSTANTS +++ ++++++++++++++++++++++++++++++++++++++++++++++++++ */


/* +++ OBJECT MEMBERS +++ +++++++++++++++++++++++++++++++++++++++++++++++++++ */


    /**
     * @var     array
     */
    protected array $_formatCasts = [
        'active'     => 'boolean',
        'created_at' => 'datetime',
        'deleted_at' => 'datetime',
        'internal'   => 'boolean',
        'updated_at' => 'datetime',
    ];


    /**
     * Specifies the columns to use and their order
     *
     * @var     array
     */
    protected array $_gridColumns = [
        'id',
        'identifier',
        'master_id',
        'domain',
        'path',
        'active',
        'internal',
    ];


    /**
     * @var     string
     */
    protected string $_gridLocaleFile = 'globals::tenants';


    /**
     * @var     string
     */
    protected string $_modelClass = Tenant::class;


    /**
     * @var     array
     */
    protected array $_searchFields = [
        'identifier'
    ];


    /**
     * @var     array
     */
    protected $listeners = [
        'tenant-created' => 'render',
        'tenant-saved'   => 'render',
    ];


/* +++ CLASS MEMBERS +++ ++++++++++++++++++++++++++++++++++++++++++++++++++++ */


/* +++ OBJECT METHODS +++ +++++++++++++++++++++++++++++++++++++++++++++++++++ */


    /**
     *
     * @return      array|Collection|LengthAwarePaginator<Tenant>
     *
     * @version     2.0.0 / 2026-06-09
     * @author      Emilio Cannarozzo <emilio.cannarozzo@bplan-solutions.de>
     * @author      Wassilios Meletiadis <wassilios.meletiadis@bplan-solutions.de>
     */
    private function _getData(): array|Collection|LengthAwarePaginator
    {
        return IndexCollectionRepository::getTenants(
            ExtendQuery: $this->_getQuery(),
            orderBy: $this->_getOrderBy()
        );
    } // _getData()


    /**
     *
     * @return      DataGrid
     *
     * @version     1.0.0 / 2026-05-25
     * @author      Emilio Cannarozzo <emilio.cannarozzo@bplan-solutions.de>
     * @author      Wassilios Meletiadis <wassilios.meletiadis@bplan-solutions.de>
     */
    private function _getGrid(): DataGrid
    {
        $gridData = $this->_getData();

        return (new DataGrid('tenant'))
            ->setActions([
                'edit-tenant',
            ])
            ->setActionSvgIcons([
                'edit-tenant' => svg_icon('globals.svg-icons.action-edit'),
            ])
            ->setActiveFilters($this->_hasActiveFilters())
            ->setColumnCallback(function ($Item, $property, $value) {
                switch ($property) {
                    case 'active':
                        if ($value === true) {
                            $value = svg_icon('globals.svg-icons.status-active', 'data-tippy-content="'.__('globals::global.status.active').'"');
                        } else {
                            $value = svg_icon('globals.svg-icons.status-inactive', 'data-tippy-content="'.__('globals::global.status.inactive').'"');
                        }
                        break;

                    case 'domain':
                        // ...
                        break;

                    case 'id':
                        // ...
                        break;

                    case 'identifier':
                        // ...
                        break;

                    case 'internal':
                        if ($value === true) {
                            $value = svg_icon('globals.svg-icons.status-active', 'data-tippy-content="'.__('globals::global.status.active').'"');
                        } else {
                            $value = svg_icon('globals.svg-icons.status-inactive', 'data-tippy-content="'.__('globals::global.status.inactive').'"');
                        }
                        break;

                    case 'master_id':
                        $value = $Item->masterTenant?->identifier;
                        break;

                    case 'path':
                        // ...
                        break;
                }
                return $value;
            })
            ->setColumns($this->_gridColumns)
            ->setData($gridData)
            ->setLocaleFile($this->_gridLocaleFile)
            ->setSorting($this->sortColumns, $this->sortColumn, $this->sortDirection)
            ->useCaptions(true)
            ->useDefaultCreateButton(true)
            ->useDefaultSearch(true);

    } // _getGrid()


    /**
     *
     * @version     1.0.0 / 2026-05-25
     * @author      Emilio Cannarozzo <emilio.cannarozzo@bplan-solutions.de>
     * @author      Wassilios Meletiadis <wassilios.meletiadis@bplan-solutions.de>
     */
    public function render()
    {
        return view('globals::livewire.core.tenant.index', [
            'grid' => $this->_getGrid(),
        ]);
    } // render()


/* +++ CLASS METHODS +++ ++++++++++++++++++++++++++++++++++++++++++++++++++++ */


} // class Index extends Component {}
